declare type SynorConfig = import('..').SynorConfig;
declare type MigrationRecord = import('./migration').MigrationRecord;
declare type MigrationSource = import('./migration').MigrationSource;
export interface DatabaseEngine {
    open(): Promise<void>;
    close(): Promise<void>;
    lock(): Promise<void>;
    unlock(): Promise<void>;
    drop(): Promise<void>;
    run(migration: MigrationSource): Promise<void>;
    repair(records: Array<Pick<MigrationRecord, 'id' | 'hash'>>): Promise<void>;
    records(startId?: number): Promise<MigrationRecord[]>;
}
export declare type DatabaseEngineFactory = (uri: SynorConfig['databaseUri'], helpers: Pick<SynorConfig, 'baseVersion' | 'getAdvisoryLockId' | 'getUserInfo'>) => DatabaseEngine;
declare type SynorDatabaseConfig = Pick<SynorConfig, 'DatabaseEngine' | 'databaseUri' | 'baseVersion' | 'getAdvisoryLockId' | 'getUserInfo'>;
export declare function SynorDatabase({ DatabaseEngine, databaseUri, baseVersion, getAdvisoryLockId, getUserInfo }: SynorDatabaseConfig): DatabaseEngine;
export {};
