declare type MigrationRecord = import('./migration').MigrationRecord;
declare type SynorDatabaseErrorType = 'lock_error' | 'unlock_error';
declare type SynorMigrationErrorType = 'not_found';
declare type SynorValidationErrorType = 'dirty' | 'hash_mismatch';
declare type SynorErrorType = SynorDatabaseErrorType | SynorMigrationErrorType | SynorValidationErrorType | 'exception';
export declare class SynorError extends Error {
    type: SynorErrorType;
    data: any;
    constructor(message: string, data?: any, type?: SynorErrorType);
}
declare type SynorDatabaseErrorMeta = {
    lockId?: string;
};
export declare class SynorDatabaseError extends SynorError {
    type: SynorDatabaseErrorType;
    data: SynorDatabaseErrorMeta;
    constructor(type: 'lock_error' | 'unlock_error', data: Required<Pick<SynorDatabaseErrorMeta, 'lockId'>>);
}
export declare class SynorMigrationError extends SynorError {
    type: SynorMigrationErrorType;
    data: Partial<MigrationRecord>;
    constructor(type: SynorMigrationErrorType, data: Partial<MigrationRecord>);
}
export declare class SynorValidationError extends SynorError {
    type: SynorValidationErrorType;
    data: MigrationRecord;
    constructor(type: SynorValidationErrorType, data: MigrationRecord);
}
export {};
