/// <reference types="node" />
export declare type MigrationType = 'DO' | 'UNDO';
export declare type MigrationVersion = string;
export declare type MigrationInfo = {
    version: MigrationVersion;
    type: MigrationType;
    title: string;
    filename: string;
};
export declare type MigrationInfoParser = (migrationFilename: string) => MigrationInfo;
export declare type MigrationSource = {
    version: MigrationVersion;
    type: MigrationType;
    title: string;
    hash: string;
    body: string;
};
export declare type MigrationRecord = {
    id: number;
    version: MigrationVersion;
    type: MigrationType;
    title: string;
    hash: string;
    appliedAt: Date;
    appliedBy: string;
    executionTime: number;
    dirty: boolean;
};
export declare type MigrationRecordState = 'applied' | 'reverted';
export declare type MigrationHistory = Array<MigrationRecord & {
    state: MigrationRecordState;
    revertedBy: number | null;
}>;
export declare const getMigrationInfoParser: ({ migrationInfoNotation }: import("..").SynorConfig) => MigrationInfoParser;
export declare function SynorMigration({ version, type, title }: MigrationInfo, content: Buffer): MigrationSource;
