/// <reference types="node" />
declare type MigrationInfo = import('./migration').MigrationInfo;
declare type SynorConfig = import('..').SynorConfig;
declare type MigrationType = MigrationInfo['type'];
declare type MigrationVersion = MigrationInfo['version'];
export interface SourceEngine {
    open(): Promise<void>;
    close(): Promise<void>;
    first(): Promise<string | null>;
    prev(version: string): Promise<string | null>;
    next(version: string): Promise<string | null>;
    last(): Promise<string | null>;
    get(version: MigrationVersion, type: MigrationType): Promise<MigrationInfo | null>;
    read(migrationInfo: MigrationInfo): Promise<Buffer>;
}
export declare type SourceEngineFactory = (uri: SynorConfig['sourceUri'], helpers: Pick<SynorConfig, 'migrationInfoParser'>) => SourceEngine;
declare type SynorSourceConfig = Pick<SynorConfig, 'SourceEngine' | 'sourceUri' | 'migrationInfoParser'>;
export declare function SynorSource({ SourceEngine, sourceUri, migrationInfoParser }: SynorSourceConfig): SourceEngine;
export {};
