'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var mysql = require('mysql');
var perf_hooks = require('perf_hooks');
var util = require('util');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

/* eslint-disable no-dupe-class-members */
var SynorError =
/*#__PURE__*/
function (_Error) {
  _inherits(SynorError, _Error);

  function SynorError(message) {
    var _this;

    var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'exception';

    _classCallCheck(this, SynorError);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SynorError).call(this, message));
    Error.captureStackTrace(_assertThisInitialized(_this), _this.constructor);
    _this.name = _this.constructor.name;
    _this.type = type;
    _this.data = data;
    return _this;
  }

  return SynorError;
}(_wrapNativeSuper(Error));
var SynorDatabaseError =
/*#__PURE__*/
function (_SynorError) {
  _inherits(SynorDatabaseError, _SynorError);

  function SynorDatabaseError(type, data) {
    _classCallCheck(this, SynorDatabaseError);

    return _possibleConstructorReturn(this, _getPrototypeOf(SynorDatabaseError).call(this, 'SynorDatabaseError', data, type));
  }

  return SynorDatabaseError;
}(SynorError);

function _empty() {}

function _awaitIgnored(value, direct) {
  if (!direct) {
    return value && value.then ? value.then(_empty) : Promise.resolve();
  }
}

function _call(body, then, direct) {
  if (direct) {
    return then ? then(body()) : body();
  }

  try {
    var result = Promise.resolve(body());
    return then ? result.then(then) : result;
  } catch (e) {
    return Promise.reject(e);
  }
}

function _callIgnored(body, direct) {
  return _call(body, _empty, direct);
}

function _invokeIgnored(body) {
  var result = body();

  if (result && result.then) {
    return result.then(_empty);
  }
}

var _iteratorSymbol =
/*#__PURE__*/
typeof Symbol !== "undefined" ? Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator")) : "@@iterator";

function _settle(pact, state, value) {
  if (!pact.s) {
    if (value instanceof _Pact) {
      if (value.s) {
        if (state & 1) {
          state = value.s;
        }

        value = value.v;
      } else {
        value.o = _settle.bind(null, pact, state);
        return;
      }
    }

    if (value && value.then) {
      value.then(_settle.bind(null, pact, state), _settle.bind(null, pact, 2));
      return;
    }

    pact.s = state;
    pact.v = value;
    var observer = pact.o;

    if (observer) {
      observer(pact);
    }
  }
}

var _Pact =
/*#__PURE__*/
function () {
  function _Pact() {}

  _Pact.prototype.then = function (onFulfilled, onRejected) {
    var result = new _Pact();
    var state = this.s;

    if (state) {
      var callback = state & 1 ? onFulfilled : onRejected;

      if (callback) {
        try {
          _settle(result, 1, callback(this.v));
        } catch (e) {
          _settle(result, 2, e);
        }

        return result;
      } else {
        return this;
      }
    }

    this.o = function (_this) {
      try {
        var value = _this.v;

        if (_this.s & 1) {
          _settle(result, 1, onFulfilled ? onFulfilled(value) : value);
        } else if (onRejected) {
          _settle(result, 1, onRejected(value));
        } else {
          _settle(result, 2, value);
        }
      } catch (e) {
        _settle(result, 2, e);
      }
    };

    return result;
  };

  return _Pact;
}();

function _isSettledPact(thenable) {
  return thenable instanceof _Pact && thenable.s & 1;
}

function _forTo(array, body, check) {
  var i = -1,
      pact,
      reject;

  function _cycle(result) {
    try {
      while (++i < array.length && (!check || !check())) {
        result = body(i);

        if (result && result.then) {
          if (_isSettledPact(result)) {
            result = result.v;
          } else {
            result.then(_cycle, reject || (reject = _settle.bind(null, pact = new _Pact(), 2)));
            return;
          }
        }
      }

      if (pact) {
        _settle(pact, 1, result);
      } else {
        pact = result;
      }
    } catch (e) {
      _settle(pact || (pact = new _Pact()), 2, e);
    }
  }

  _cycle();

  return pact;
}

function _forOf(target, body, check) {
  if (typeof target[_iteratorSymbol] === "function") {
    var _cycle2 = function _cycle2(result) {
      try {
        while (!(step = iterator.next()).done && (!check || !check())) {
          result = body(step.value);

          if (result && result.then) {
            if (_isSettledPact(result)) {
              result = result.v;
            } else {
              result.then(_cycle2, reject || (reject = _settle.bind(null, pact = new _Pact(), 2)));
              return;
            }
          }
        }

        if (pact) {
          _settle(pact, 1, result);
        } else {
          pact = result;
        }
      } catch (e) {
        _settle(pact || (pact = new _Pact()), 2, e);
      }
    };

    var iterator = target[_iteratorSymbol](),
        step,
        pact,
        reject;

    _cycle2();

    if (iterator["return"]) {
      var _fixup = function _fixup(value) {
        try {
          if (!step.done) {
            iterator["return"]();
          }
        } catch (e) {}

        return value;
      };

      if (pact && pact.then) {
        return pact.then(_fixup, function (e) {
          throw _fixup(e);
        });
      }

      _fixup();
    }

    return pact;
  } // No support for Symbol.iterator


  if (!("length" in target)) {
    throw new TypeError("Object is not iterable");
  } // Handle live collections properly


  var values = [];

  for (var i = 0; i < target.length; i++) {
    values.push(target[i]);
  }

  return _forTo(values, function (i) {
    return body(values[i]);
  }, check);
}

function _continue(value, then) {
  return value && value.then ? value.then(then) : then(value);
}

function _invoke(body, then) {
  var result = body();

  if (result && result.then) {
    return result.then(then);
  }

  return then(result);
}

function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var ensureMigrationRecordTable = _async(function (queryStore, baseVersion) {
  return _await(queryStore.getMigrationTableColumnNames(), function (existingColumnNames) {
    var migrationTableExists = Boolean(existingColumnNames.length);
    var startTime = perf_hooks.performance.now();
    return _invoke(function () {
      if (!migrationTableExists) {
        return _awaitIgnored(queryStore.createMigrationTable());
      }
    }, function () {
      return _continue(_forOf(Object.entries(queryStore.addColumn), function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            columnName = _ref2[0],
            addColumn = _ref2[1];

        return _invokeIgnored(function () {
          if (!existingColumnNames.includes(columnName)) {
            return _callIgnored(addColumn);
          }
        });
      }), function () {
        var endTime = perf_hooks.performance.now();
        return _invokeIgnored(function () {
          if (!migrationTableExists) {
            return _awaitIgnored(queryStore.addRecord({
              version: baseVersion,
              type: 'DO',
              title: 'Base Migration',
              hash: '',
              appliedAt: new Date(),
              appliedBy: 'Synor',
              executionTime: endTime - startTime,
              dirty: false
            }));
          }
        });
      });
    });
  });
});

function _async$1(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var runQuery = _async$1(function (connection, query) {
  var values = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  return new Promise(function (resolve, reject) {
    connection.query(query, values, function (err, results) {
      if (err) {
        reject(err);
        return;
      }

      resolve(results);
    });
  });
});
function getQueryStore(connection, _ref) {
  var tableName = _ref.migrationTableName,
      databaseName = _ref.databaseName,
      advisoryLockId = _ref.advisoryLockId;
  var openConnection = util.promisify(function (callback) {
    return connection.connect(callback);
  });
  var closeConnection = util.promisify(function (callback) {
    return connection.end(callback);
  });

  var QueryRunner = function QueryRunner(query, values) {
    var formatter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function (v) {
      return v;
    };
    return function () {
      return runQuery(connection, query.replace(/\s+/, ' ').trim(), values).then(formatter);
    };
  };

  var getMigrationTableColumnNames = QueryRunner("\n      SELECT column_name\n      FROM information_schema.columns\n      WHERE table_name = ? AND table_schema = ?;\n    ", [tableName, databaseName], function (rows) {
    return rows.map(function (_ref2) {
      var column_name = _ref2.column_name;
      return column_name;
    });
  });
  var createMigrationTable = QueryRunner("\n      CREATE TABLE ?? (\n        ?? INT NOT NULL AUTO_INCREMENT,\n        CONSTRAINT ?? PRIMARY KEY (??)\n      );\n    ", [tableName, 'id', "".concat(tableName, "_pk"), 'id']);
  var addColumn = {
    version: QueryRunner("\n        ALTER TABLE ??\n          ADD COLUMN ?? VARCHAR(128) NOT NULL;\n      ", [tableName, 'version']),
    type: QueryRunner("\n        ALTER TABLE ??\n          ADD COLUMN ?? VARCHAR(16);\n      ", [tableName, 'type']),
    title: QueryRunner("\n        ALTER TABLE ??\n          ADD COLUMN ?? TEXT;\n      ", [tableName, 'title']),
    hash: QueryRunner("\n        ALTER TABLE ??\n          ADD COLUMN ?? TEXT;\n      ", [tableName, 'hash']),
    applied_at: QueryRunner("\n        ALTER TABLE ??\n          ADD COLUMN ?? TIMESTAMP DEFAULT CURRENT_TIMESTAMP;\n      ", [tableName, 'applied_at']),
    applied_by: QueryRunner("\n        ALTER TABLE ??\n          ADD COLUMN ?? VARCHAR(255);\n      ", [tableName, 'applied_by']),
    execution_time: QueryRunner("\n        ALTER TABLE ??\n          ADD COLUMN ?? INT;\n      ", [tableName, 'execution_time']),
    dirty: QueryRunner("\n        ALTER TABLE ??\n          ADD COLUMN ?? BOOLEAN DEFAULT false;\n      ", [tableName, 'dirty'])
  };
  var getLock = QueryRunner("\n      SELECT GET_LOCK(?, -1) AS synor_lock;\n    ", [advisoryLockId], function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 1),
        synor_lock = _ref4[0].synor_lock;

    return synor_lock;
  });
  var releaseLock = QueryRunner("\n      SELECT RELEASE_LOCK(?) AS synor_lock;\n    ", [advisoryLockId], function (_ref5) {
    var _ref6 = _slicedToArray(_ref5, 1),
        synor_lock = _ref6[0].synor_lock;

    return synor_lock;
  });
  var getTableNames = QueryRunner("\n      SELECT table_name\n      FROM information_schema.tables\n      WHERE table_schema = ?\n    ", [databaseName], function (rows) {
    return rows.map(function (_ref7) {
      var table_name = _ref7.table_name;
      return table_name;
    });
  });

  var dropTables = function dropTables(tableNames) {
    return QueryRunner(["SET FOREIGN_KEY_CHECKS = 0;"].concat(_toConsumableArray(tableNames.map(function () {
      return "DROP TABLE IF EXISTS ??;";
    })), ["SET FOREIGN_KEY_CHECKS = 1;"]).join('\n'), _toConsumableArray(tableNames))();
  };

  var getRecords = function getRecords() {
    var startId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    return QueryRunner("\n        SELECT ??, ??, ??, ??, ??, ?? AS ?, ?? AS ?, ?? AS ?, ??\n        FROM ??\n        WHERE ?? >= ?;\n      ", ['id', 'version', 'type', 'title', 'hash', 'applied_at', 'appliedAt', 'applied_by', 'appliedBy', 'execution_time', 'executionTime', 'dirty', tableName, 'id', startId], function (rows) {
      return rows.map(function (row) {
        return Object.assign({}, row, {
          dirty: Boolean(row.dirty)
        });
      });
    })();
  };

  var addRecord = function addRecord(_ref8) {
    var version = _ref8.version,
        type = _ref8.type,
        title = _ref8.title,
        hash = _ref8.hash,
        appliedAt = _ref8.appliedAt,
        appliedBy = _ref8.appliedBy,
        executionTime = _ref8.executionTime,
        _ref8$dirty = _ref8.dirty,
        dirty = _ref8$dirty === void 0 ? false : _ref8$dirty;
    return QueryRunner("\n        INSERT INTO ?? (\n          ??, ??, ??, ??, ??, ??, ??, ??\n        ) VALUES (\n          ?, ?, ?, ?, ?, ?, ?, ?\n        )\n      ", [tableName, 'version', 'type', 'title', 'hash', 'applied_at', 'applied_by', 'execution_time', 'dirty', version, type, title, hash, appliedAt, appliedBy, executionTime, dirty])();
  };

  var deleteDirtyRecords = QueryRunner("\n      DELETE FROM ?? WHERE ?? = ?;\n    ", [tableName, 'dirty', true]);

  var updateRecord = _async$1(function (id, _ref9) {
    var hash = _ref9.hash;
    return QueryRunner("\n        UPDATE ?? SET ?? = ?\n          WHERE ?? = ?;\n      ", [tableName, 'hash', hash, 'id', id])();
  });

  return {
    openConnection: openConnection,
    closeConnection: closeConnection,
    getMigrationTableColumnNames: getMigrationTableColumnNames,
    createMigrationTable: createMigrationTable,
    addColumn: addColumn,
    getLock: getLock,
    releaseLock: releaseLock,
    getTableNames: getTableNames,
    dropTables: dropTables,
    getRecords: getRecords,
    addRecord: addRecord,
    deleteDirtyRecords: deleteDirtyRecords,
    updateRecord: updateRecord
  };
}

function _empty$1() {}

function _awaitIgnored$1(value, direct) {
  if (!direct) {
    return value && value.then ? value.then(_empty$1) : Promise.resolve();
  }
}

function _await$1(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _call$1(body, then, direct) {
  if (direct) {
    return then ? then(body()) : body();
  }

  try {
    var result = Promise.resolve(body());
    return then ? result.then(then) : result;
  } catch (e) {
    return Promise.reject(e);
  }
}

function _async$2(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

function _catch(body, recover) {
  try {
    var result = body();
  } catch (e) {
    return recover(e);
  }

  if (result && result.then) {
    return result.then(void 0, recover);
  }

  return result;
}

function _rethrow(thrown, value) {
  if (thrown) throw value;
  return value;
}

function _finallyRethrows(body, finalizer) {
  try {
    var result = body();
  } catch (e) {
    return finalizer(true, e);
  }

  if (result && result.then) {
    return result.then(finalizer.bind(null, false), finalizer.bind(null, true));
  }

  return finalizer(false, result);
}

var _iteratorSymbol$1 =
/*#__PURE__*/
typeof Symbol !== "undefined" ? Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator")) : "@@iterator";

function _settle$1(pact, state, value) {
  if (!pact.s) {
    if (value instanceof _Pact$1) {
      if (value.s) {
        if (state & 1) {
          state = value.s;
        }

        value = value.v;
      } else {
        value.o = _settle$1.bind(null, pact, state);
        return;
      }
    }

    if (value && value.then) {
      value.then(_settle$1.bind(null, pact, state), _settle$1.bind(null, pact, 2));
      return;
    }

    pact.s = state;
    pact.v = value;
    var observer = pact.o;

    if (observer) {
      observer(pact);
    }
  }
}

var _Pact$1 =
/*#__PURE__*/
function () {
  function _Pact() {}

  _Pact.prototype.then = function (onFulfilled, onRejected) {
    var result = new _Pact();
    var state = this.s;

    if (state) {
      var callback = state & 1 ? onFulfilled : onRejected;

      if (callback) {
        try {
          _settle$1(result, 1, callback(this.v));
        } catch (e) {
          _settle$1(result, 2, e);
        }

        return result;
      } else {
        return this;
      }
    }

    this.o = function (_this) {
      try {
        var value = _this.v;

        if (_this.s & 1) {
          _settle$1(result, 1, onFulfilled ? onFulfilled(value) : value);
        } else if (onRejected) {
          _settle$1(result, 1, onRejected(value));
        } else {
          _settle$1(result, 2, value);
        }
      } catch (e) {
        _settle$1(result, 2, e);
      }
    };

    return result;
  };

  return _Pact;
}();

function _isSettledPact$1(thenable) {
  return thenable instanceof _Pact$1 && thenable.s & 1;
}

function _forTo$1(array, body, check) {
  var i = -1,
      pact,
      reject;

  function _cycle(result) {
    try {
      while (++i < array.length && (!check || !check())) {
        result = body(i);

        if (result && result.then) {
          if (_isSettledPact$1(result)) {
            result = result.v;
          } else {
            result.then(_cycle, reject || (reject = _settle$1.bind(null, pact = new _Pact$1(), 2)));
            return;
          }
        }
      }

      if (pact) {
        _settle$1(pact, 1, result);
      } else {
        pact = result;
      }
    } catch (e) {
      _settle$1(pact || (pact = new _Pact$1()), 2, e);
    }
  }

  _cycle();

  return pact;
}

function _forOf$1(target, body, check) {
  if (typeof target[_iteratorSymbol$1] === "function") {
    var _cycle2 = function _cycle2(result) {
      try {
        while (!(step = iterator.next()).done && (!check || !check())) {
          result = body(step.value);

          if (result && result.then) {
            if (_isSettledPact$1(result)) {
              result = result.v;
            } else {
              result.then(_cycle2, reject || (reject = _settle$1.bind(null, pact = new _Pact$1(), 2)));
              return;
            }
          }
        }

        if (pact) {
          _settle$1(pact, 1, result);
        } else {
          pact = result;
        }
      } catch (e) {
        _settle$1(pact || (pact = new _Pact$1()), 2, e);
      }
    };

    var iterator = target[_iteratorSymbol$1](),
        step,
        pact,
        reject;

    _cycle2();

    if (iterator["return"]) {
      var _fixup = function _fixup(value) {
        try {
          if (!step.done) {
            iterator["return"]();
          }
        } catch (e) {}

        return value;
      };

      if (pact && pact.then) {
        return pact.then(_fixup, function (e) {
          throw _fixup(e);
        });
      }

      _fixup();
    }

    return pact;
  } // No support for Symbol.iterator


  if (!("length" in target)) {
    throw new TypeError("Object is not iterable");
  } // Handle live collections properly


  var values = [];

  for (var i = 0; i < target.length; i++) {
    values.push(target[i]);
  }

  return _forTo$1(values, function (i) {
    return body(values[i]);
  }, check);
}

function _continueIgnored(value) {
  if (value && value.then) {
    return value.then(_empty$1);
  }
}

function getMySQLConfig(uri) {
  var _ref = new URL(uri),
      pathname = _ref.pathname,
      hostname = _ref.hostname,
      port = _ref.port,
      username = _ref.username,
      password = _ref.password,
      searchParams = _ref.searchParams;

  var ssl;

  if (searchParams.has('ssl')) {
    var sslRaw = searchParams.get('ssl');

    try {
      ssl = JSON.parse(sslRaw);
    } catch (_unused) {
      ssl = sslRaw;
    }
  }

  return {
    database: pathname.replace(/^\//, ''),
    host: hostname,
    port: Number(port),
    user: username,
    password: password,
    multipleStatements: true,
    ssl: ssl
  };
}

function getEngineConfig(uri) {
  var _ref2 = new URL(uri),
      params = _ref2.searchParams;

  var migrationTableName = params.get('synor-migration-record-table') || 'synor_migration_record';
  return {
    migrationTableName: migrationTableName
  };
}

var MySQLDatabaseEngine = function MySQLDatabaseEngine(uri, _ref3) {
  var baseVersion = _ref3.baseVersion,
      getAdvisoryLockId = _ref3.getAdvisoryLockId,
      getUserInfo = _ref3.getUserInfo;
  var engineConfig = getEngineConfig(uri);
  var mysqlConfig = getMySQLConfig(uri);
  var advisoryLockId = getAdvisoryLockId(mysqlConfig.database, engineConfig.migrationTableName).join(':');
  var connection = mysql.createConnection(mysqlConfig);
  var queryStore = getQueryStore(connection, {
    migrationTableName: engineConfig.migrationTableName,
    databaseName: mysqlConfig.database,
    advisoryLockId: advisoryLockId
  });
  var appliedBy = '';

  var open = function open() {
    return _call$1(getUserInfo, function (_getUserInfo) {
      appliedBy = _getUserInfo;
      return _await$1(queryStore.openConnection(), function () {
        return _awaitIgnored$1(ensureMigrationRecordTable(queryStore, baseVersion));
      });
    });
  };

  var close = _async$2(function () {
    return _awaitIgnored$1(queryStore.closeConnection());
  });

  var lock = _async$2(function () {
    return _await$1(queryStore.getLock(), function (lockResult) {
      if ([0, null].includes(lockResult)) {
        throw new SynorDatabaseError('lock_error', {
          lockId: advisoryLockId
        });
      }
    });
  });

  var unlock = _async$2(function () {
    return _await$1(queryStore.releaseLock(), function (lockResult) {
      if ([0, null].includes(lockResult)) {
        throw new SynorDatabaseError('unlock_error', {
          lockId: advisoryLockId
        });
      }
    });
  });

  var drop = _async$2(function () {
    return _await$1(queryStore.getTableNames(), function (tableNames) {
      return _awaitIgnored$1(queryStore.dropTables(tableNames));
    });
  });

  var run = _async$2(function (_ref4) {
    var version = _ref4.version,
        type = _ref4.type,
        title = _ref4.title,
        hash = _ref4.hash,
        body = _ref4.body;
    var dirty = false;
    var startTime = perf_hooks.performance.now();
    return _finallyRethrows(function () {
      return _catch(function () {
        return _awaitIgnored$1(runQuery(connection, body));
      }, function (err) {
        dirty = true;
        throw err;
      });
    }, function (_wasThrown, _result) {
      var endTime = perf_hooks.performance.now();
      return _await$1(queryStore.addRecord({
        version: version,
        type: type,
        title: title,
        hash: hash,
        appliedAt: new Date(),
        appliedBy: appliedBy,
        executionTime: endTime - startTime,
        dirty: dirty
      }), function () {
        return _rethrow(_wasThrown, _result);
      });
    });
  });

  var repair = _async$2(function (records) {
    return _await$1(queryStore.deleteDirtyRecords(), function () {
      return _continueIgnored(_forOf$1(records, function (_ref5) {
        var id = _ref5.id,
            hash = _ref5.hash;
        return _awaitIgnored$1(queryStore.updateRecord(id, {
          hash: hash
        }));
      }));
    });
  });

  var records = _async$2(function (startId) {
    return queryStore.getRecords(startId);
  });

  return {
    migrationTableName: engineConfig.migrationTableName,
    open: open,
    close: close,
    lock: lock,
    unlock: unlock,
    drop: drop,
    run: run,
    repair: repair,
    records: records
  };
};

exports.MySQLDatabaseEngine = MySQLDatabaseEngine;
