import { SynorMigrator } from './core/migrator';
declare type DatabaseEngineFactory = import('./core/database').DatabaseEngineFactory;
declare type GetAdvisoryLockId = import('./utils/get-advisory-lock-id').GetAdvisoryLockId;
declare type GetUserInfo = import('./utils/get-user-info').GetUserInfo;
declare type MigrationInfoParser = import('./core/migration').MigrationInfoParser;
declare type MigrationVersion = import('./core/migration').MigrationVersion;
declare type SourceEngineFactory = import('./core/source').SourceEngineFactory;
declare type Synor = {
    migrator: SynorMigrator;
};
export declare type SynorConfig = {
    sourceUri: string;
    SourceEngine: SourceEngineFactory;
    databaseUri: string;
    DatabaseEngine: DatabaseEngineFactory;
    baseVersion: MigrationVersion;
    recordStartId: number;
    migrationInfoNotation: {
        do: string;
        undo: string;
        seperator: string;
    };
    migrationInfoParser: MigrationInfoParser;
    getAdvisoryLockId: GetAdvisoryLockId;
    getUserInfo: GetUserInfo;
};
export declare function Synor(synorConfig: Partial<SynorConfig>): Synor;
export {};
