import defaultsDeep from 'lodash.defaultsdeep';
import crypto from 'crypto';
import { EventEmitter } from 'events';
import { exec } from 'child_process';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

/* eslint-disable no-dupe-class-members */
var SynorError =
/*#__PURE__*/
function (_Error) {
  _inherits(SynorError, _Error);

  function SynorError(message) {
    var _this;

    var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'exception';

    _classCallCheck(this, SynorError);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SynorError).call(this, message));
    Error.captureStackTrace(_assertThisInitialized(_this), _this.constructor);
    _this.name = _this.constructor.name;
    _this.type = type;
    _this.data = data;
    return _this;
  }

  return SynorError;
}(_wrapNativeSuper(Error));
var SynorMigrationError =
/*#__PURE__*/
function (_SynorError2) {
  _inherits(SynorMigrationError, _SynorError2);

  function SynorMigrationError(type, data) {
    _classCallCheck(this, SynorMigrationError);

    return _possibleConstructorReturn(this, _getPrototypeOf(SynorMigrationError).call(this, 'SynorMigrationError', data, type));
  }

  return SynorMigrationError;
}(SynorError);
var SynorValidationError =
/*#__PURE__*/
function (_SynorError3) {
  _inherits(SynorValidationError, _SynorError3);

  function SynorValidationError(type, data) {
    _classCallCheck(this, SynorValidationError);

    return _possibleConstructorReturn(this, _getPrototypeOf(SynorValidationError).call(this, 'SynorValidationError', data, type));
  }

  return SynorValidationError;
}(SynorError);

function getHash(content) {
  var sanitizedContent = content.replace(/[\r\n]+/gm, '\n').trim();
  return crypto.createHash('sha256').update(sanitizedContent, 'utf8').digest('hex');
}

function getMigrationInfoRegex(_ref) {
  var DO = _ref["do"],
      UNDO = _ref.undo,
      SEPERATOR = _ref.seperator;
  var version = "[0-9]+";
  var type = [DO, UNDO].join('|');
  var title = '.+';
  return new RegExp("^(".concat(version, ").(").concat(type, ")").concat(SEPERATOR, "(").concat(title, ")(?:\\.(.+))?$"), 'i');
}

var getMigrationInfoParser = function getMigrationInfoParser(_ref2) {
  var _typeMap;

  var migrationInfoNotation = _ref2.migrationInfoNotation;
  var migrationInfoRegex = getMigrationInfoRegex(migrationInfoNotation);
  var typeMap = (_typeMap = {}, _defineProperty(_typeMap, migrationInfoNotation["do"].toUpperCase(), 'DO'), _defineProperty(_typeMap, migrationInfoNotation.undo.toUpperCase(), 'UNDO'), _typeMap);
  return function (migrationFilename) {
    var infoMatches = migrationFilename.match(migrationInfoRegex);

    if (infoMatches === null) {
      throw new SynorError("Invalid Filename: ".concat(migrationFilename));
    }

    var _infoMatches = _slicedToArray(infoMatches, 4),
        filename = _infoMatches[0],
        version = _infoMatches[1],
        type = _infoMatches[2],
        title = _infoMatches[3];

    return {
      version: version,
      type: typeMap[type.toUpperCase()],
      title: title,
      filename: filename
    };
  };
};
function SynorMigration(_ref3, content) {
  var version = _ref3.version,
      type = _ref3.type,
      title = _ref3.title;
  var migration = {
    version: version,
    type: type,
    title: title,

    get hash() {
      return getHash(this.body);
    },

    get body() {
      return content.toString('utf8');
    }

  };
  return migration;
}

function SynorDatabase(_ref) {
  var DatabaseEngine = _ref.DatabaseEngine,
      databaseUri = _ref.databaseUri,
      baseVersion = _ref.baseVersion,
      getAdvisoryLockId = _ref.getAdvisoryLockId,
      getUserInfo = _ref.getUserInfo;
  return DatabaseEngine(databaseUri, {
    baseVersion: baseVersion,
    getAdvisoryLockId: getAdvisoryLockId,
    getUserInfo: getUserInfo
  });
}

function SynorSource(_ref) {
  var SourceEngine = _ref.SourceEngine,
      sourceUri = _ref.sourceUri,
      migrationInfoParser = _ref.migrationInfoParser;
  return SourceEngine(sourceUri, {
    migrationInfoParser: migrationInfoParser
  });
}

function getCurrentVersion(history) {
  var appliedMigrations = history.filter(function (_ref) {
    var state = _ref.state,
        type = _ref.type;
    return state === 'applied' && type === 'DO';
  }).sort(function (a, b) {
    return a.id - b.id;
  });
  var currentVersion = appliedMigrations[appliedMigrations.length - 1].version;
  return currentVersion;
}

function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var getHistory = _async(function (database, baseVersion, recordStartId) {
  return _await(database.records(recordStartId), function (records) {
    var lastIndexByVersion = {};
    var history = records.map(function (record) {
      return Object.assign({}, record, {
        state: 'applied',
        revertedBy: null
      });
    });
    history.forEach(function (_ref, index) {
      var id = _ref.id,
          version = _ref.version;

      if (version === baseVersion) {
        return;
      }

      var lastIndex = lastIndexByVersion[version];

      if (lastIndex) {
        history[lastIndex].state = 'reverted';
        history[lastIndex].revertedBy = id;
      }

      lastIndexByVersion[version] = index;
    });
    return history;
  });
});

function _await$1(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _async$1(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var getMigration = _async$1(function (source, version, type) {
  return _await$1(source.get(version, type), function (info) {
    return info ? _await$1(source.read(info), function (content) {
      var migration = SynorMigration(info, content);
      return migration;
    }) : null;
  });
});

function _await$2(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _settle(pact, state, value) {
  if (!pact.s) {
    if (value instanceof _Pact) {
      if (value.s) {
        if (state & 1) {
          state = value.s;
        }

        value = value.v;
      } else {
        value.o = _settle.bind(null, pact, state);
        return;
      }
    }

    if (value && value.then) {
      value.then(_settle.bind(null, pact, state), _settle.bind(null, pact, 2));
      return;
    }

    pact.s = state;
    pact.v = value;
    var observer = pact.o;

    if (observer) {
      observer(pact);
    }
  }
}

var _Pact =
/*#__PURE__*/
function () {
  function _Pact() {}

  _Pact.prototype.then = function (onFulfilled, onRejected) {
    var result = new _Pact();
    var state = this.s;

    if (state) {
      var callback = state & 1 ? onFulfilled : onRejected;

      if (callback) {
        try {
          _settle(result, 1, callback(this.v));
        } catch (e) {
          _settle(result, 2, e);
        }

        return result;
      } else {
        return this;
      }
    }

    this.o = function (_this) {
      try {
        var value = _this.v;

        if (_this.s & 1) {
          _settle(result, 1, onFulfilled ? onFulfilled(value) : value);
        } else if (onRejected) {
          _settle(result, 1, onRejected(value));
        } else {
          _settle(result, 2, value);
        }
      } catch (e) {
        _settle(result, 2, e);
      }
    };

    return result;
  };

  return _Pact;
}();

function _isSettledPact(thenable) {
  return thenable instanceof _Pact && thenable.s & 1;
}

function _for(test, update, body) {
  var stage;

  for (;;) {
    var shouldContinue = test();

    if (_isSettledPact(shouldContinue)) {
      shouldContinue = shouldContinue.v;
    }

    if (!shouldContinue) {
      return result;
    }

    if (shouldContinue.then) {
      stage = 0;
      break;
    }

    var result = body();

    if (result && result.then) {
      if (_isSettledPact(result)) {
        result = result.s;
      } else {
        stage = 1;
        break;
      }
    }

    if (update) {
      var updateValue = update();

      if (updateValue && updateValue.then && !_isSettledPact(updateValue)) {
        stage = 2;
        break;
      }
    }
  }

  var pact = new _Pact();

  var reject = _settle.bind(null, pact, 2);

  (stage === 0 ? shouldContinue.then(_resumeAfterTest) : stage === 1 ? result.then(_resumeAfterBody) : updateValue.then(_resumeAfterUpdate)).then(void 0, reject);
  return pact;

  function _resumeAfterBody(value) {
    result = value;

    do {
      if (update) {
        updateValue = update();

        if (updateValue && updateValue.then && !_isSettledPact(updateValue)) {
          updateValue.then(_resumeAfterUpdate).then(void 0, reject);
          return;
        }
      }

      shouldContinue = test();

      if (!shouldContinue || _isSettledPact(shouldContinue) && !shouldContinue.v) {
        _settle(pact, 1, result);

        return;
      }

      if (shouldContinue.then) {
        shouldContinue.then(_resumeAfterTest).then(void 0, reject);
        return;
      }

      result = body();

      if (_isSettledPact(result)) {
        result = result.v;
      }
    } while (!result || !result.then);

    result.then(_resumeAfterBody).then(void 0, reject);
  }

  function _resumeAfterTest(shouldContinue) {
    if (shouldContinue) {
      result = body();

      if (result && result.then) {
        result.then(_resumeAfterBody).then(void 0, reject);
      } else {
        _resumeAfterBody(result);
      }
    } else {
      _settle(pact, 1, result);
    }
  }

  function _resumeAfterUpdate() {
    if (shouldContinue = test()) {
      if (shouldContinue.then) {
        shouldContinue.then(_resumeAfterTest).then(void 0, reject);
      } else {
        _resumeAfterTest(shouldContinue);
      }
    } else {
      _settle(pact, 1, result);
    }
  }
}

function _empty() {}

function _continueIgnored(value) {
  if (value && value.then) {
    return value.then(_empty);
  }
}

function _invoke(body, then) {
  var result = body();

  if (result && result.then) {
    return result.then(then);
  }

  return then(result);
}

function _async$2(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var getMigrationsToRun = _async$2(function (source, baseVersion, fromVersion, toVersion) {
  var migrations = [];
  var type;

  if (fromVersion < toVersion) {
    type = 'DO';
  } else if (fromVersion > toVersion) {
    type = 'UNDO';
  } else {
    return migrations;
  }

  return _invoke(function () {
    if (fromVersion !== baseVersion) {
      return _await$2(source.get(fromVersion, type), function (fromVersionExist) {
        if (!fromVersionExist) {
          throw new SynorMigrationError('not_found', {
            version: fromVersion,
            type: type
          });
        }
      });
    }
  }, function (_result) {
    return _invoke(function () {
      if (toVersion !== baseVersion) {
        return _await$2(source.get(toVersion, type), function (toVersionExist) {
          if (!toVersionExist) {
            throw new SynorMigrationError('not_found', {
              version: toVersion,
              type: type
            });
          }
        });
      }
    }, function (_result2) {
      return  _invoke(function () {
        if (type === 'DO') {
          return _await$2(fromVersion === baseVersion ? source.first() : source.next(fromVersion), function (nextVersion) {
            return _continueIgnored(_for(function () {
              return !!nextVersion;
            }, void 0, function () {
              return _await$2(getMigration(source, nextVersion, type), function (migration) {
                if (!migration) {
                  nextVersion = null;
                  return;
                }

                migrations.push(migration);

                if (migration.version === toVersion) {
                  nextVersion = null;
                  return;
                }

                return _await$2(source.next(migration.version), function (_source$next) {
                  nextVersion = _source$next;
                });
              });
            }));
          });
        }
      }, function () {
        return _invoke(function () {
          if (type === 'UNDO') {
            var prevVersion = fromVersion === baseVersion ? null : fromVersion;
            return _continueIgnored(_for(function () {
              return !!prevVersion;
            }, void 0, function () {
              return _await$2(getMigration(source, prevVersion, type), function (migration) {
                if (!migration) {
                  prevVersion = null;
                  return;
                }

                if (migration.version === toVersion) {
                  prevVersion = null;
                  return;
                }

                migrations.push(migration);
                return _await$2(source.prev(migration.version), function (_source$prev) {
                  prevVersion = _source$prev;
                });
              });
            }));
          }
        }, function () {
          return migrations;
        });
      });
    });
  });
});

function _await$3(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

var _iteratorSymbol =
/*#__PURE__*/
typeof Symbol !== "undefined" ? Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator")) : "@@iterator";

function _settle$1(pact, state, value) {
  if (!pact.s) {
    if (value instanceof _Pact$1) {
      if (value.s) {
        if (state & 1) {
          state = value.s;
        }

        value = value.v;
      } else {
        value.o = _settle$1.bind(null, pact, state);
        return;
      }
    }

    if (value && value.then) {
      value.then(_settle$1.bind(null, pact, state), _settle$1.bind(null, pact, 2));
      return;
    }

    pact.s = state;
    pact.v = value;
    var observer = pact.o;

    if (observer) {
      observer(pact);
    }
  }
}

var _Pact$1 =
/*#__PURE__*/
function () {
  function _Pact() {}

  _Pact.prototype.then = function (onFulfilled, onRejected) {
    var result = new _Pact();
    var state = this.s;

    if (state) {
      var callback = state & 1 ? onFulfilled : onRejected;

      if (callback) {
        try {
          _settle$1(result, 1, callback(this.v));
        } catch (e) {
          _settle$1(result, 2, e);
        }

        return result;
      } else {
        return this;
      }
    }

    this.o = function (_this) {
      try {
        var value = _this.v;

        if (_this.s & 1) {
          _settle$1(result, 1, onFulfilled ? onFulfilled(value) : value);
        } else if (onRejected) {
          _settle$1(result, 1, onRejected(value));
        } else {
          _settle$1(result, 2, value);
        }
      } catch (e) {
        _settle$1(result, 2, e);
      }
    };

    return result;
  };

  return _Pact;
}();

function _isSettledPact$1(thenable) {
  return thenable instanceof _Pact$1 && thenable.s & 1;
}

function _forTo(array, body, check) {
  var i = -1,
      pact,
      reject;

  function _cycle(result) {
    try {
      while (++i < array.length && (!check || !check())) {
        result = body(i);

        if (result && result.then) {
          if (_isSettledPact$1(result)) {
            result = result.v;
          } else {
            result.then(_cycle, reject || (reject = _settle$1.bind(null, pact = new _Pact$1(), 2)));
            return;
          }
        }
      }

      if (pact) {
        _settle$1(pact, 1, result);
      } else {
        pact = result;
      }
    } catch (e) {
      _settle$1(pact || (pact = new _Pact$1()), 2, e);
    }
  }

  _cycle();

  return pact;
}

function _forOf(target, body, check) {
  if (typeof target[_iteratorSymbol] === "function") {
    var _cycle2 = function _cycle2(result) {
      try {
        while (!(step = iterator.next()).done && (!check || !check())) {
          result = body(step.value);

          if (result && result.then) {
            if (_isSettledPact$1(result)) {
              result = result.v;
            } else {
              result.then(_cycle2, reject || (reject = _settle$1.bind(null, pact = new _Pact$1(), 2)));
              return;
            }
          }
        }

        if (pact) {
          _settle$1(pact, 1, result);
        } else {
          pact = result;
        }
      } catch (e) {
        _settle$1(pact || (pact = new _Pact$1()), 2, e);
      }
    };

    var iterator = target[_iteratorSymbol](),
        step,
        pact,
        reject;

    _cycle2();

    if (iterator["return"]) {
      var _fixup = function _fixup(value) {
        try {
          if (!step.done) {
            iterator["return"]();
          }
        } catch (e) {}

        return value;
      };

      if (pact && pact.then) {
        return pact.then(_fixup, function (e) {
          throw _fixup(e);
        });
      }

      _fixup();
    }

    return pact;
  } // No support for Symbol.iterator


  if (!("length" in target)) {
    throw new TypeError("Object is not iterable");
  } // Handle live collections properly


  var values = [];

  for (var i = 0; i < target.length; i++) {
    values.push(target[i]);
  }

  return _forTo(values, function (i) {
    return body(values[i]);
  }, check);
}

function _continue(value, then) {
  return value && value.then ? value.then(then) : then(value);
}

function _async$3(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var getRecordsToRepair = _async$3(function (source, baseVersion, history) {
  var _exit = false;
  var appliedRecords = history.filter(function (_ref) {
    var state = _ref.state,
        dirty = _ref.dirty;
    return state === 'applied' && !dirty;
  });
  var mismatchedRecords = [];
  return _continue(_forOf(appliedRecords, function (_ref2) {
    var id = _ref2.id,
        version = _ref2.version,
        type = _ref2.type,
        hash = _ref2.hash;

    if (version === baseVersion) {
      return;
    }

    return _await$3(getMigration(source, version, type), function (migration) {
      if (!migration) {
        throw new SynorMigrationError('not_found', {
          id: id,
          version: version,
          type: type
        });
      }

      if (migration.hash !== hash) {
        mismatchedRecords.push({
          id: id,
          hash: migration.hash
        });
      }
    });
  }, function () {
    return _exit;
  }), function (_result) {
    return  mismatchedRecords;
  });
});

function validateMigration(record, migration) {
  if (record.dirty) {
    throw new SynorValidationError('dirty', record);
  }

  if (record.hash !== migration.hash) {
    throw new SynorValidationError('hash_mismatch', record);
  }
}

function _empty$1() {}

function _awaitIgnored(value, direct) {
  if (!direct) {
    return value && value.then ? value.then(_empty$1) : Promise.resolve();
  }
}

function _await$4(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _catch(body, recover) {
  try {
    var result = body();
  } catch (e) {
    return recover(e);
  }

  if (result && result.then) {
    return result.then(void 0, recover);
  }

  return result;
}

function _rethrow(thrown, value) {
  if (thrown) throw value;
  return value;
}

function _finallyRethrows(body, finalizer) {
  try {
    var result = body();
  } catch (e) {
    return finalizer(true, e);
  }

  if (result && result.then) {
    return result.then(finalizer.bind(null, false), finalizer.bind(null, true));
  }

  return finalizer(false, result);
}

function _continueIgnored$1(value) {
  if (value && value.then) {
    return value.then(_empty$1);
  }
}

function _async$4(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var _iteratorSymbol$1 =
/*#__PURE__*/
typeof Symbol !== "undefined" ? Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator")) : "@@iterator";

function _settle$2(pact, state, value) {
  if (!pact.s) {
    if (value instanceof _Pact$2) {
      if (value.s) {
        if (state & 1) {
          state = value.s;
        }

        value = value.v;
      } else {
        value.o = _settle$2.bind(null, pact, state);
        return;
      }
    }

    if (value && value.then) {
      value.then(_settle$2.bind(null, pact, state), _settle$2.bind(null, pact, 2));
      return;
    }

    pact.s = state;
    pact.v = value;
    var observer = pact.o;

    if (observer) {
      observer(pact);
    }
  }
}

var _Pact$2 =
/*#__PURE__*/
function () {
  function _Pact() {}

  _Pact.prototype.then = function (onFulfilled, onRejected) {
    var result = new _Pact();
    var state = this.s;

    if (state) {
      var callback = state & 1 ? onFulfilled : onRejected;

      if (callback) {
        try {
          _settle$2(result, 1, callback(this.v));
        } catch (e) {
          _settle$2(result, 2, e);
        }

        return result;
      } else {
        return this;
      }
    }

    this.o = function (_this) {
      try {
        var value = _this.v;

        if (_this.s & 1) {
          _settle$2(result, 1, onFulfilled ? onFulfilled(value) : value);
        } else if (onRejected) {
          _settle$2(result, 1, onRejected(value));
        } else {
          _settle$2(result, 2, value);
        }
      } catch (e) {
        _settle$2(result, 2, e);
      }
    };

    return result;
  };

  return _Pact;
}();

function _isSettledPact$2(thenable) {
  return thenable instanceof _Pact$2 && thenable.s & 1;
}

function _forTo$1(array, body, check) {
  var i = -1,
      pact,
      reject;

  function _cycle(result) {
    try {
      while (++i < array.length && (!check || !check())) {
        result = body(i);

        if (result && result.then) {
          if (_isSettledPact$2(result)) {
            result = result.v;
          } else {
            result.then(_cycle, reject || (reject = _settle$2.bind(null, pact = new _Pact$2(), 2)));
            return;
          }
        }
      }

      if (pact) {
        _settle$2(pact, 1, result);
      } else {
        pact = result;
      }
    } catch (e) {
      _settle$2(pact || (pact = new _Pact$2()), 2, e);
    }
  }

  _cycle();

  return pact;
}

function _forOf$1(target, body, check) {
  if (typeof target[_iteratorSymbol$1] === "function") {
    var _cycle2 = function _cycle2(result) {
      try {
        while (!(step = iterator.next()).done && (!check || !check())) {
          result = body(step.value);

          if (result && result.then) {
            if (_isSettledPact$2(result)) {
              result = result.v;
            } else {
              result.then(_cycle2, reject || (reject = _settle$2.bind(null, pact = new _Pact$2(), 2)));
              return;
            }
          }
        }

        if (pact) {
          _settle$2(pact, 1, result);
        } else {
          pact = result;
        }
      } catch (e) {
        _settle$2(pact || (pact = new _Pact$2()), 2, e);
      }
    };

    var iterator = target[_iteratorSymbol$1](),
        step,
        pact,
        reject;

    _cycle2();

    if (iterator["return"]) {
      var _fixup = function _fixup(value) {
        try {
          if (!step.done) {
            iterator["return"]();
          }
        } catch (e) {}

        return value;
      };

      if (pact && pact.then) {
        return pact.then(_fixup, function (e) {
          throw _fixup(e);
        });
      }

      _fixup();
    }

    return pact;
  } // No support for Symbol.iterator


  if (!("length" in target)) {
    throw new TypeError("Object is not iterable");
  } // Handle live collections properly


  var values = [];

  for (var i = 0; i < target.length; i++) {
    values.push(target[i]);
  }

  return _forTo$1(values, function (i) {
    return body(values[i]);
  }, check);
}

function _continue$1(value, then) {
  return value && value.then ? value.then(then) : then(value);
}

var SynorMigrator =
/*#__PURE__*/
function (_EventEmitter) {
  _inherits(SynorMigrator, _EventEmitter);

  function SynorMigrator(config) {
    var _this;

    _classCallCheck(this, SynorMigrator);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SynorMigrator).call(this));

    _this.decorate = function (startEvent, handler, endEvent) {
      return _async$4(function () {
        for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
          params[_key] = arguments[_key];
        }

        return _continueIgnored$1(_finallyRethrows(function () {
          return _catch(function () {
            return _await$4(_this.lock(), function () {
              _this.emit(startEvent);

              return _awaitIgnored(handler.apply(void 0, params));
            });
          }, function (error) {
            _this.emit('error', error);
          });
        }, function (_wasThrown, _result) {
          _this.emit(endEvent);

          return _await$4(_this.unlock(), function () {
            return _rethrow(_wasThrown, _result);
          });
        }));
      });
    };

    _this.emitOrThrow = function (event, data, error) {
      var hasListener = _this.emit(event, data, error);

      if (!hasListener) {
        throw error;
      }
    };

    _this.lock = _async$4(function () {
      _this.emit('lock:start');

      if (_this.locked) {
        throw new SynorError('Already Locked');
      }

      return _await$4(_this.database.lock(), function () {
        _this.locked = true;

        _this.emit('lock:end');
      });
    });
    _this.unlock = _async$4(function () {
      _this.emit('unlock:start');

      if (!_this.locked) {
        throw new SynorError('Not Locked');
      }

      return _await$4(_this.database.unlock(), function () {
        _this.locked = false;

        _this.emit('unlock:end');
      });
    });
    _this.open = _async$4(function () {
      _this.emit('open:start');

      return _await$4(Promise.all([_this.database.open(), _this.source.open()]), function () {
        _this.emit('open:end');
      });
    });
    _this.close = _async$4(function () {
      _this.emit('close:start');

      return _await$4(Promise.all([_this.database.close(), _this.source.close()]), function () {
        _this.emit('close:end');
      });
    });
    _this.drop = _async$4(function () {
      return _awaitIgnored(_this.database.drop());
    });
    _this.version = _async$4(function () {
      var _this$config = _this.config,
          baseVersion = _this$config.baseVersion,
          recordStartId = _this$config.recordStartId;
      return _await$4(getHistory(_this.database, baseVersion, recordStartId), function (history) {
        var currentVersion = getCurrentVersion(history);

        _this.emit('version', currentVersion);
      });
    });
    _this.history = _async$4(function (recordStartId) {
      if (recordStartId === undefined) recordStartId = _this.config.recordStartId;
      var baseVersion = _this.config.baseVersion;
      return _await$4(getHistory(_this.database, baseVersion, recordStartId), function (history) {
        _this.emit('history', history);
      });
    });
    _this.pending = _async$4(function () {
      var _this$config2 = _this.config,
          baseVersion = _this$config2.baseVersion,
          recordStartId = _this$config2.recordStartId;
      return _await$4(getHistory(_this.database, baseVersion, recordStartId), function (history) {
        var currentVersion = getCurrentVersion(history);
        return _await$4(_this.source.last(), function (targetVersion) {
          if (!targetVersion || currentVersion >= targetVersion) {
            _this.emit('pending', []);

            return;
          }

          return _await$4(getMigrationsToRun(_this.source, baseVersion, currentVersion, targetVersion), function (migrations) {
            _this.emit('pending', migrations);
          });
        });
      });
    });
    _this.validate = _async$4(function () {
      var _this$config3 = _this.config,
          baseVersion = _this$config3.baseVersion,
          recordStartId = _this$config3.recordStartId;
      return _await$4(getHistory(_this.database, baseVersion, recordStartId).then(function (history) {
        return history.filter(function (_ref) {
          var version = _ref.version,
              type = _ref.type,
              state = _ref.state;
          return version !== baseVersion && type === 'DO' && state === 'applied';
        });
      }), function (records) {
        var _exit = false;
        return _forOf$1(records, function (record) {
          _this.emit('validate:run:start', record);

          return _await$4(getMigration(_this.source, record.version, record.type), function (migration) {
            if (!migration) {
              throw new SynorMigrationError('not_found', record);
            }

            try {
              validateMigration(record, migration);
            } catch (error) {
              _this.emitOrThrow('validate:error', record, error);
            }

            _this.emit('validate:run:end', record);
          });
        }, function () {
          return _exit;
        });
      });
    });
    _this.migrate = _async$4(function (targetVersion) {
      var _this$config4 = _this.config,
          baseVersion = _this$config4.baseVersion,
          recordStartId = _this$config4.recordStartId;
      return _await$4(getHistory(_this.database, baseVersion, recordStartId), function (history) {
        var currentVersion = getCurrentVersion(history);
        return _await$4(getMigrationsToRun(_this.source, baseVersion, currentVersion, targetVersion), function (migrations) {
          return _continueIgnored$1(_forOf$1(migrations, function (migration) {
            _this.emit('migrate:run:start', migration);

            return _continue$1(_catch(function () {
              return _awaitIgnored(_this.database.run(migration));
            }, function (error) {
              _this.emitOrThrow('migrate:error', migration, error);
            }), function () {
              _this.emit('migrate:run:end', migration);
            });
          }));
        });
      });
    });
    _this.repair = _async$4(function () {
      var _this$config5 = _this.config,
          baseVersion = _this$config5.baseVersion,
          recordStartId = _this$config5.recordStartId;
      return _await$4(getHistory(_this.database, baseVersion, recordStartId), function (history) {
        return _await$4(getRecordsToRepair(_this.source, baseVersion, history), function (records) {
          return _awaitIgnored(_this.database.repair(records));
        });
      });
    });

    _this.setMaxListeners(1);

    _this.config = config;
    _this.database = SynorDatabase(config);
    _this.source = SynorSource(config);
    _this.locked = false;
    _this.drop = _this.decorate('drop:start', _this.drop, 'drop:end');
    _this.version = _this.decorate('version:start', _this.version, 'version:end');
    _this.history = _this.decorate('history:start', _this.history, 'history:end');
    _this.pending = _this.decorate('pending:start', _this.pending, 'pending:end');
    _this.validate = _this.decorate('validate:start', _this.validate, 'validate:end');
    _this.migrate = _this.decorate('migrate:start', _this.migrate, 'migrate:end');
    _this.repair = _this.decorate('repair:start', _this.repair, 'repair:end');
    return _this;
  }

  return SynorMigrator;
}(EventEmitter);

/**
 * JavaScript CRC32 - Stack Overflow - Alex
 * https://stackoverflow.com/a/18639999/4456924
 */
function generateCRC32Table() {
  var crcTable = [];
  var c;

  for (var n = 0; n < 256; n++) {
    c = n;

    for (var k = 0; k < 8; k++) {
      c = c & 1 ? 0xedb88320 ^ c >>> 1 : c >>> 1;
    }

    crcTable[n] = c;
  }

  return crcTable;
}

var crcTable = generateCRC32Table();
function crc32(str) {
  var crc = 0 ^ -1;

  for (var i = 0; i < str.length; i++) {
    crc = crc >>> 8 ^ crcTable[(crc ^ str.charCodeAt(i)) & 0xff];
  }

  return (crc ^ -1) >>> 0;
}

var synorChecksum = crc32('SYNOR');
var getAdvisoryLockId = function getAdvisoryLockId(databaseName) {
  for (var _len = arguments.length, additionalNames = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    additionalNames[_key - 1] = arguments[_key];
  }

  var identifier = [databaseName].concat(additionalNames).join("\0");
  var checksum = crc32(identifier);
  return [String(synorChecksum), String(checksum)];
};

function _async$5(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

function _await$5(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

var getGitUserInfo = _async$5(function () {
  return _await$5(Promise.all([getGitConfigValue('user.name'), getGitConfigValue('user.email')]), function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        name = _ref2[0],
        email = _ref2[1];

    return "".concat(name || 'N/A').concat(email ? " <".concat(email, ">") : '');
  });
});

var getGitConfigValue = _async$5(function (key) {
  return new Promise(function (resolve) {
    exec("git config --get ".concat(key), function (err, stdout) {
      if (err) {
        resolve('');
        return;
      }

      resolve(stdout.split(/\n/)[0]);
    });
  });
});

var defaultConfig = {
  baseVersion: '0',
  recordStartId: 0,
  migrationInfoNotation: {
    "do": 'do',
    undo: 'undo',
    seperator: '.'
  },
  getAdvisoryLockId: getAdvisoryLockId,
  getUserInfo: getGitUserInfo
};
function Synor(synorConfig) {
  var config = defaultsDeep(synorConfig, defaultConfig);

  if (typeof config.migrationInfoParser !== 'function') {
    config.migrationInfoParser = getMigrationInfoParser(config);
  }

  var migrator = new SynorMigrator(config);
  return {
    migrator: migrator
  };
}

export { Synor };
